VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "RUBS_V100"
   ClientHeight    =   4365
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6240
   LinkTopic       =   "Form1"
   ScaleHeight     =   4365
   ScaleWidth      =   6240
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid List1 
      Height          =   2105
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   3704
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      AllowUserResizing=   1
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "StartCheck"
      Height          =   375
      Left            =   2460
      TabIndex        =   2
      Tag             =   "0"
      Top             =   3840
      Width           =   1320
   End
   Begin VB.TextBox errMsg 
      Height          =   285
      Left            =   120
      Locked          =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   3360
      Width           =   5895
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Check on properties to be 'up to date' and no sick relations"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   5895
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "check Asm "
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   233
      TabIndex        =   0
      Top             =   240
      Width           =   5775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Copyright (C)2005 Klaus Dahlenburg, INCOMM GmbH
'
' Published under the terms and conditions of GNU General Public License Version 2, 1991 or later
'
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
'
' changes:
'
'========================
'
Option Explicit

Private objApp As SolidEdgeFramework.Application
Private objDoc As AssemblyDocument
Private coFiles As Collection
Private sFilename As String
Private sFehler As String
Private fso As FileSystemObject
'
Private Sub cmdCopy_Click()
'
Dim vTemp As Variant
Dim sUpdate As String
Dim sChkRel As String
Dim bUser As Boolean       ' False physical properties are out of date
Dim bSick As Boolean       ' TRUE denotes an relationship failure in one of the parts
'
    sFehler = vbNullString
    errMsg.Text = vbNullString
    '
    ' check on active SolidEdge
    If Not chkEnv() Then
        Unload Me
        Exit Sub
    End If
    '
    Set coFiles = New Collection
    List1.Rows = 1
    If getAsmPhysProps(0, bUser, objDoc, bSick) Then
        If Not bUser Or bSick Then
            coFiles.Add Array(bUser, bSick, objDoc.Name), Trim(objDoc.Name)
        End If
    Else
        errMsg.Text = sFehler
    End If
    errMsg.Text = "Running ..."
    DoEvents
    If getOccQty(objDoc.Occurrences, coFiles) Then
        For Each vTemp In coFiles
            sUpdate = IIf(vTemp(0), vbNullString, "Updte")
            sChkRel = IIf(vTemp(1), "ChkRel", vbNullString)
            List1.AddItem sUpdate & vbTab & sChkRel & vbTab & vTemp(2)
        Next
    Else
        errMsg.Text = sFehler
    End If
    '
    If errMsg.Text = vbNullString Then
        errMsg.Text = "End of Run"
    End If
    '
End Sub

' --------------------
' activate the form and check on active SE and base file
' If no base file is given we do nothing here (see cmdList_click() )
' --------------------
Private Sub Form_Activate()
'
    errMsg.Text = vbNullString
    errMsg.Visible = True
    Form1.Caption = App.Title
    '
    ' check on SolidEdge
    If Not chkEnv() Then
        Unload Me
    End If
'
End Sub
' --------------------
' load the form and do the housekeeping
' --------------------
Private Sub Form_Load()
'
    List1.ColWidth(0) = 600
    List1.ColWidth(1) = 600
    List1.ColWidth(2) = List1.Width - 1590
    List1.FixedRows = 0
    List1.Rows = 0
    List1.AddItem "PProps" & vbTab & "Relns." & vbTab & "Filename"
    ' add new line
    List1.AddItem 0
    List1.RowHeight(1) = 0
    List1.FixedRows = 1
    Set fso = New FileSystemObject
'
End Sub
' --------------------
' application ends
' --------------------
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'
    Set objDoc = Nothing
    Set objApp = Nothing
    Set coFiles = Nothing
'
End Sub
' -----------------------------------
' startup checking
' -----------------------------------
Private Function chkEnv() As Boolean
'
    On Error GoTo 0
    On Error Resume Next
    chkEnv = False
    '
    '
    ' now connect to SolidEdge
    Do
        Set objApp = GetObject(, "SolidEdge.Application")
        If Err Then
            If MsgBox("SolidEdge muss mit einer .ASM gestartet sein", vbInformation + vbRetryCancel) = vbCancel Then
                Exit Function
            End If
        Else
            '
            ' any documents open
            If objApp.Documents.Count < 1 Then
                If MsgBox("Es ist keine Datei geffnet", vbInformation + vbRetryCancel) = vbCancel Then
                    Exit Function
                End If
            Else
                '
                ' Make sure a sheetmetal document is open.
                If objApp.ActiveDocument.Type <> igAssemblyDocument Then
                    If MsgBox("Die aktive Datei ist keine ASM-Datei", _
                              vbInformation + vbRetryCancel) = vbCancel Then
                        Exit Function
                    End If
                Else
                    'Test to see if this file has been saved by
                    'parsing objSMDoc.Name for a .asm extension
                    If StrComp(Right$(objApp.ActiveDocument.FullName, 4), ".asm", 1) <> 0 Then
                        If MsgBox("Die Datei muss noch gespeichert werden", vbInformation + vbRetryCancel) = vbCancel Then
                            Exit Function
                        End If
                    Else
                        '
                        'Make sure the document contains at least one part
                        If objApp.ActiveDocument.Occurrences.Count < 1 Then
                            If MsgBox("Die Datei enthaelt keine Teile", vbInformation + vbRetryCancel) = vbCancel Then
                               Exit Function
                            End If
                        Else
                            Exit Do         ' we're OK so get out of loop
                        End If
                    End If
                End If
            End If
        End If
        Err.Clear
    Loop
    '
    ' when the document was close we must set some pointers again
    Set objDoc = objApp.ActiveDocument
    chkEnv = True
    '
End Function
' ----------------------------------
' Count all items in an Assembly Document that are to be included in BOM
' recursive walk through all Occurrences the main ASM holds
'
' Parameter: pOccs, Occurrences, Input
'            pCntSubAsm, Boolean, Optional, TRUE (Default) count subasm, FALSE do not count
' RC: TRUE no error raised, FALSE otherwise; sFehler set
'
' pFiles   will hold all counted items. The structure is:
'          count as long
'          object as Occurrence
' ----------------------------------
Public Function getOccQty(ByVal pOccs As Occurrences, _
            ByRef pFiles As Collection) As Boolean
'
Dim objOcc As Occurrence
Dim vTemp As Variant
Dim dMass As Double
Dim bUpdte As Boolean
Dim bSick As Boolean              ' Asm only TRUE denotes an relationship failure in one of the parts
Dim sShortName As String
Dim bUProps As Boolean
Dim lStatus As Long
'
    On Error GoTo err_handler:
    getOccQty = False
    sFehler = vbNullString
    bUpdte = False
    '
    For Each objOcc In pOccs
        bSick = False
        bUpdte = True
        bUProps = False
        lStatus = 0
        On Error GoTo 0
        '
        vTemp = InStrRev(objOcc.Name, ":", -1, vbTextCompare)
        If vTemp <> 0 Then
            sShortName = Left(objOcc.Name, vTemp - 1)
        Else
            sShortName = objOcc.Name
        End If
        '
        ' check whether file exists
        '
        If Not fso.FileExists(objOcc.OccurrenceFileName) Then
            On Error Resume Next
            pFiles.Add Array(False, True, "Missing " & objOcc.Name), Trim(sShortName)
            Err.Clear
            On Error GoTo err_handler:
            GoTo continue:                    ' next occurrence
        End If
        '
        ' filter out wanted documents
        Select Case objOcc.OccurrenceDocument.Type
            Case igPartDocument, igAssemblyDocument, igSheetMetalDocument
                '
            Case Else
                GoTo continue:
        End Select
        '
        ' first get invalid relations
        For Each vTemp In objOcc.Relations3d
            If Not vTemp.Suppress Then
                If vTemp.Status = igRelation3dStatusUnsolved Then
                    bSick = True
                    Exit For
                End If
            End If
        Next vTemp
        '
        ' for an assembly additional check on updte
        If objOcc.Subassembly Then
            If Not getAsmPhysProps(0, bUpdte, objOcc.OccurrenceDocument, True) Then
                GoTo cleanup:
            End If
        Else
            ' only interested in userprops and Status
            If getPPs(0, 0, 0, bUProps, False, objOcc.OccurrenceDocument, lStatus) Then
                If Not bUProps And lStatus <> 1 Then
                    bUpdte = True
                End If
            End If
        End If
        '
        ' if only an update is neccessary we'll store only once
        If Not bUpdte Or bSick Then
            On Error Resume Next
            vTemp = Empty
            If Not bUpdte Then
                vTemp = pFiles.Item(sShortName)    ' RC would be 5 but this may change
            End If
            '
            ' if still empty it's a new or 'sick' item to be added to the collection
            If (IsEmpty(vTemp) Or Err.Number <> 0) Or bSick Then
                Err.Clear
                pFiles.Add Array(bUpdte, bSick, objOcc.Name), Trim(sShortName)
            End If
        End If
        '
        On Error GoTo err_handler:
        If objOcc.Subassembly Then
            If Not getOccQty(objOcc.OccurrenceDocument.Occurrences, pFiles) Then
                GoTo cleanup:
            End If
        End If  ' /* If objOcc.Subassembly */
continue:
    Next objOcc
    getOccQty = True
    '
cleanup:
    Set objOcc = Nothing
    Exit Function
'
' error handler
'
'
err_handler:
    sFehler = "Error in method getOccQty(): " & Err.Description
    Resume cleanup:
'
End Function
' --------------------------------------------------
' Obtain the Density and accuracy from the current document
'
' Return:
'  getAsmPhysProps pUpdate     pMass    pSick
'      true        True       Value  True/False   OK, mass should be reliable
'      true        False     (Value) True/False   the assembly's properties are not up to date
'                                                 (ASM needs an update, Mass unreliable)
'      False       false         0      n/a       error    = sFehler set to last error description
'
' Note: if pSick = True if any of the occurrences in the assembly has had a failure when
'       recomputing associative relationships
' --------------------------------------------------
Public Function getAsmPhysProps(ByRef pMass As Double, _
                            ByRef pUpdate As Boolean, _
                            pObjDoc As Object, _
                            Optional pSick As Boolean = False) As Boolean
'
Dim bSick As Boolean
Dim bUpdte As Boolean
Static dDummy() As Double            ' we must supply an array for some args
'
    On Error GoTo 0
    On Error GoTo err_handler:
    pMass = 0#
    pUpdate = True
    pSick = False
    getAsmPhysProps = False
    sFehler = vbNullString
    
    Call pObjDoc.PhysicalProperties.GetAssemblyPhysicalProperties(pMass, 0, 0, _
                                    dDummy, dDummy, dDummy, dDummy, dDummy, dDummy, dDummy, dDummy, pSick, pUpdate)
    getAsmPhysProps = True
    Exit Function
err_handler:
    sFehler = Err.Number & " / " & Err.Description
    Exit Function
'
End Function
' --------------------------------------------------
' Obtain the Density, accuracy and mass from the current document
' Arguments:
'           pDens double, Output,    Density
'           pAccu double, Output,    Accuracy
'           pMass double, OutPut,    Mass
'           pUProps Boolean, Output  see below
'           pCVal   Boolean, Output  see below
'           poDoc   Object, Input    the object pointing to valid SE file
'           pStatus Long, Input/output, Optional  upon return holds the status unchanged on error
' Return:
'  getPP   pUProps  pCVal  pdens   pAccu   pMass
'   true    true     n/a     0       0       0     never set (would denote Status = 2 on PhysProps)
'   true    false    n/a   Value   Value  Value/0  PhysProps present, value as returned by system
'                                                  status can be 2 then the mass is 0
'   false   true    True  (Value) (Value)  Value   UserPhysProps present, (value) when found in vars; -1 otherwise
'   false   false    n/a     0       0      0      either no Model = sFehler set (program defined)
'                                                  or     error    = sFehler set to last error description
'
' Required external:
'          sFehler, String, to receive the error message
' --------------------------------------------------
'
Public Function getPPs(ByRef pDens As Double, _
                       ByRef pAccu As Double, _
                       ByRef pMass As Double, _
                       ByRef pUProps As Boolean, _
                       ByRef pCVal As Boolean, _
                       poDoc As Object, _
                       Optional ByRef pStatus As Long = -1) As Boolean
'
Static objMod As Model
Static objDoc As Object
Static dDummy() As Double    ' can be used as placeholder for we must supply an array for some args
Static lStatus As Long       ' 0 = out of date, 1 = up to date, 2 = not calculated yet
Static objVarList As Object
Static i As Long
Static dblUsrMass As Double
'
' these will be reset on each call to 0 which must be done
' because SE won't return any 0 value and ehen not reset one
' will use old values
'
Dim dblAccuracyIn As Double
Dim dblAccuracyOut As Double
Dim dblVolume As Double
Dim dblArea As Double
Dim dblMass As Double
Dim dblCofGravity() As Double
Dim dblCofVolume() As Double
Dim dblGlobalMoments() As Double
Dim dblPrincipalMoments() As Double
Dim dblPrincipalAxes() As Double
Dim dblRadiiOfGyration() As Double
Dim lngStatus As Long
Dim dblStartRadiusArray(1 To 4) As Double
Dim dblEndRadiusArray(1 To 4) As Double
'
'
    sFehler = vbNullString            ' external string
    pUProps = False
    getPPs = False
    pCVal = False
    On Error GoTo 0                   ' reset any err_handler
    '
    ' reset user values
    pDens = 0#
    pAccu = 0#
    pMass = 0#
    dblUsrMass = 0#
    '
    On Error GoTo getPhysProps_99:           ' skip files that do not support Models
    '
    If poDoc.Models.Count < 1 Then
        sFehler = "Document without model"
        GoTo getPhysProps_99:                ' bail out
    End If
    
    Set objMod = poDoc.Models(1)
    Set objDoc = poDoc
    '
    ' if we fail here then there are user defined properties
    ' which on setting new values will be overwritten
    ' But -- we won't fail in case the initial values had been
    ' set as user values, so we must cater for this as well
    '
    On Error Resume Next              ' catch errors
    '
    Call objMod.GetPhysicalProperties(lStatus, pDens, pAccu, _
                    dblVolume, dblArea, pMass, dblCofGravity, _
                    dblCofVolume, dblGlobalMoments, dblPrincipalMoments, _
                    dblPrincipalAxes, dblRadiiOfGyration, dblAccuracyOut)
    If Err.Number <> 0 Then   ' -2145467259 user phys. props present
        Err.Clear
        Call objDoc.GetUserPhysicalProperties(dblVolume, dblArea, pMass, dblCofGravity, _
                                    dblCofVolume, dblGlobalMoments, dblPrincipalMoments, _
                                    dblPrincipalAxes, dblRadiiOfGyration)
        If Err.Number = 0 Then
            pUProps = True
        Else
            sFehler = Err.Description
        End If
    Else
        '
        ' see if user props were initially present
        ' if that's the case the GetPhysicalProperties() method won't fail
        ' The Volume and Area are given as 0 so not to overwrite the calculated ones
        Call objDoc.GetUserPhysicalProperties(0, 0, dblUsrMass, dblCofGravity, _
                                    dblCofVolume, dblGlobalMoments, dblPrincipalMoments, _
                                    dblPrincipalAxes, dblRadiiOfGyration)
        If Err.Number = 0 Then
            pMass = dblUsrMass      ' update the mass
            pUProps = True
        Else
            '
            ' the call may have failed if user properties have never been defined
            ' also the system calculation of PPs has been done
            ' -2147467261 (automation error, invalid pointer)
            Err.Clear
            getPPs = True
        End If
    End If
    '
    '
    If pStatus <> -1 Then                     ' user want's status back
        pStatus = lStatus
    End If
    '
    ' if user defined properties are present or status = 2 we have to fetch the calculated density
    ' as well as the accuracy from the variables because either method did not returned them. In case
    ' the user renamed them SE does not preserve the original (internal) name for variables.
    ' Therefore the value for accuracy may be wrong because we picked up just a scalar
    ' The accuracy is the default one (assumption, maybe it's the achieved one)
    ' Because of the difficulties to distinguish the variables and the problem that some
    ' variables do not expose all listed methods we will give up on error
    '
    If pUProps Or lStatus = 2 Then
        On Error GoTo getPhysProps_99          ' on error skip
        '
        pCVal = True                           ' indicate values obtained from variables
        pDens = -1#                            ' indicate not found
        pAccu = -1#                            ' indicate not found
        '
        ' =================
        ' alternative method to get the density/accuracy. This values reflect the default
        ' values and may not be the actual ones!
        ' If pUserProps Or lStatus = 2 Then
        '   Call objDoc.GetGlobalParameter(sePartGlobalDensity, pDens)
        '  Call objDoc.GetGlobalParameter(sePartGlobalAccuracyForDensity, pAccu)
        ' End If
        ' =================
        '
        ' get the the variables we are interested in (igUnitScalar will also work)
        Set objVarList = objDoc.Variables.Query("*", seVariableNameByBoth, igVariable)
        '
        For i = 1 To objVarList.Count
            If objVarList(i).Type <> igDimension Then
                '
                ' look for density (16&)
                If objVarList(i).UnitsType = igUnitDensity Then
                    pDens = objVarList(i).Value           ' set density
                    '
                    ' look for a scalar (58&)
                ElseIf objVarList(i).UnitsType = igUnitScalar Then
                        '
                        ' Is it the accuracy? We found no Enum other than igUnitForcePerDistance
                        ' to have value of 29& (A user defined scalar would be 15&)
                        ' If desired a check can be inserted to see if the value is > 0 and <= 1
                        ' the check may cause trouble, remove it then
                        If objVarList(i).Properties = 29& Then
                           pAccu = objVarList(i).Value    ' set accuracy
                        End If
                End If
            End If
        Next i
    End If
    '
'
'  normal exit
'
getPhysProps_99:
    '
    Set objMod = Nothing
    Set objVarList = Nothing
    Set objDoc = Nothing
    Err.Clear
    Exit Function
'
' common error handled here
'
err_module:
    sFehler = "Error in Method getPPs(): " & Err.Description
    Resume getPhysProps_99
    '
End Function

